hdu 3466 Proud Merchants(先排序的01背包)

Problem Description
Recently, iSea went to an ancient country. For such a long time, it was the most wealthy and powerful kingdom in the world. As a result, the people in this country are still very proud even if their nation hasn’t been so wealthy any more.
The merchants were the most typical, each of them only sold exactly one item, the price was Pi, but they would refuse to make a trade with you if your money were less than Qi, and iSea evaluated every item a value Vi.
If he had M units of money, what’s the maximum value iSea could get?

 

Input
There are several test cases in the input.

Each test case begin with two integers N, M (1 ≤ N ≤ 500, 1 ≤ M ≤ 5000), indicating the items’ number and the initial money.
Then N lines follow, each line contains three numbers Pi, Qi and Vi (1 ≤ Pi ≤ Qi ≤ 100, 1 ≤ Vi ≤ 1000), their meaning is in the description.

The input terminates by end of file marker.

 

Output
For each test case, output one integer, indicating maximum value iSea could get.

 

Sample Input
  
  
2 10 10 15 10 5 10 5 3 10 5 10 5 3 5 6 2 7 3
 

Sample Output
  
  
5 11
 
题意:已知n个物品和总钱数m,第i个物品的价格为pi,限制条件为qi,即当手上的钱大于qi才能买i物品,花费pi,所获价值为
            vi,求所能获得的最大价值.
分析:由于本题在01背包的基础上多了一个限制,如果直接用01背包,答案就会出错,就比如 钱为10,第一个物品
           p、q为3 5,第二个为 5 10,若先选了第一个,第二个就不能选,实际上两个都可选。
           我最开始对q排序了,然后01背包,发现样例过了,结果一交就wrong。。。看到网上都说要按q-p的差从小到            大,也不知道为什么,按这样排后就AC了,但是就是不理解。。。
           终于在一个blog上找到了解释
           A:p1,q1   B: p2,q2,先选A,则至少需要p1+q2的容量,而先选B则至少需要p2+q1,如果p1+q2>p2+q1,那么要选两个的话的就要先选A再              选B,公式可换成q1-p1 < q2-p2,就按这样的方法排序最后的顺序就是最优的顺序。
AC代码:
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
struct stu
{
    int f,q,v;
};
int cmp(struct stu a,struct stu b)
{
    return a.q-a.f<b.q-b.f;
}
int main()
{
    struct stu s[510];
    int i,j,k,n,m,a[5010];
    while(scanf("%d%d",&n,&m)!=EOF){
        for(i=1;i<=n;i++)
            scanf("%d%d%d",&s[i].f,&s[i].q,&s[i].v);
        sort(s+1,s+n+1,cmp);
        memset(a,0,sizeof(a));
        for(i=1;i<=n;i++)
            for(j=m;j>=s[i].q;j--){
                k=a[j-s[i].f]+s[i].v;
                if(k>a[j])
                    a[j]=k;
            }
        printf("%d\n",a[m]);
    }
    return 0;
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值